#This function should run by astro_game:obstacles/actions/spawn

execute store result score spawning_roll astro_game.obstacles run random value 1..3



#Spawn blue spaceship if roll matches the spawner
execute as @e[tag=obstacle_spawner_-1] if score spawning_roll astro_game.obstacles matches 1 run function astro_game:obstacles/entities/blue_spaceship
execute as @e[tag=obstacle_spawner_0] if score spawning_roll astro_game.obstacles matches 2 run function astro_game:obstacles/entities/blue_spaceship
execute as @e[tag=obstacle_spawner_1] if score spawning_roll astro_game.obstacles matches 3 run function astro_game:obstacles/entities/blue_spaceship

#Fill asteroids in places where the spawner didn't spawn a blue spaceship
execute as @e[tag=obstacle_spawner_-1] unless score spawning_roll astro_game.obstacles matches 1 run function astro_game:obstacles/entities/asteroid
execute as @e[tag=obstacle_spawner_0] unless score spawning_roll astro_game.obstacles matches 2 run function astro_game:obstacles/entities/asteroid
execute as @e[tag=obstacle_spawner_1] unless score spawning_roll astro_game.obstacles matches 3 run function astro_game:obstacles/entities/asteroid


#Reset spawning_roll in order to prevent retriggering of other spawns
scoreboard players set spawning_roll astro_game.obstacles 2 