#This function should run by astro_game:obstacles/actions/spawn

execute store result score spawning_roll astro_game.obstacles run random value 1..3



#Spawn orange spaceship if roll matches the spawner
execute as @e[tag=obstacle_spawner_-1] if score spawning_roll astro_game.obstacles matches 1 run function astro_game:obstacles/entities/orange_spaceship
execute as @e[tag=obstacle_spawner_0] if score spawning_roll astro_game.obstacles matches 2 run function astro_game:obstacles/entities/orange_spaceship
execute as @e[tag=obstacle_spawner_1] if score spawning_roll astro_game.obstacles matches 3 run function astro_game:obstacles/entities/orange_spaceship

#Fill red spaceship in places where the spawner didn't spawn a orange spaceship
execute as @e[tag=obstacle_spawner_-1] unless score spawning_roll astro_game.obstacles matches 1 run function astro_game:obstacles/entities/red_spaceship
execute as @e[tag=obstacle_spawner_0] unless score spawning_roll astro_game.obstacles matches 2 run function astro_game:obstacles/entities/red_spaceship
execute as @e[tag=obstacle_spawner_1] unless score spawning_roll astro_game.obstacles matches 3 run function astro_game:obstacles/entities/red_spaceship


#Reset spawning_roll in order to prevent retriggering of other spawns
scoreboard players set spawning_roll astro_game.obstacles 8 