#This function should run once at the begining of the game

#Roll for random BGM
execute store result score random_buffer astro_game.bgm run random value 1..3

#Apply track length based on selected bgm
execute if score random_buffer astro_game.bgm matches 1 run scoreboard players set track_max_ticks astro_game.bgm 5248
execute if score random_buffer astro_game.bgm matches 2 run scoreboard players set track_max_ticks astro_game.bgm 3315
execute if score random_buffer astro_game.bgm matches 3 run scoreboard players set track_max_ticks astro_game.bgm 3606

stopsound @a master

#Apply play selected bgm
execute if score preset astro_game.persistent matches 1.. if score random_buffer astro_game.bgm matches 1 run playsound sounds:bgm_1 master @a[tag=game_viewer] ~ ~ ~ 0.15 1 0.15
execute if score preset astro_game.persistent matches 1.. if score random_buffer astro_game.bgm matches 2 run playsound sounds:bgm_2 master @a[tag=game_viewer] ~ ~ ~ 0.15 1 0.15
execute if score preset astro_game.persistent matches 1.. if score random_buffer astro_game.bgm matches 3 run playsound sounds:bgm_3 master @a[tag=game_viewer] ~ ~ ~ 0.15 1 0.15

#Override if tutorial
execute if score preset astro_game.persistent matches 0 run scoreboard players set track_max_ticks astro_game.bgm 13259
execute if score preset astro_game.persistent matches 0 run playsound sounds:tutorial_bgm master @a[tag=game_viewer] ~ ~ ~ 0.15 1 0.15


#Reset ticker 
scoreboard players set ticker astro_game.bgm 0