#This function should run when the game ends before the score resets 

#Exit if tutorial
execute if score preset astro_game.persistent matches 0 run return 0


#Exit if score is not highscore (means it doesn't need any processing)
execute unless score score astro_game.score > highest_score astro_game.persistent run return 0

execute if score score astro_game.score >= orange_suit_unlock_threshold astro_game.persistent as @e[tag=suit_handler,tag=orange_suit,tag=locked_suit,limit=1] run function astro_game:lobby/suits/unlock 
execute if score score astro_game.score >= black_suit_unlock_threshold astro_game.persistent as @e[tag=suit_handler,tag=black_suit,tag=locked_suit,limit=1] run function astro_game:lobby/suits/unlock 
scoreboard players operation highest_score astro_game.persistent = score astro_game.score
tellraw @a [{"text":"[!] ","color":"#28B4FB"},{"text":" A new highscore of ","color":"white"},{"score":{"name":"score","objective":"astro_game.score"},"color":"#28B4FB"},{"text":" was achieved","color":"white"}]
