#Roll for spawning count (Update this each time you add a spawning pattern)
execute store result score spawning_roll astro_game.obstacles run function astro_game:obstacles/actions/roll_for_spawn

#Spawn based on roll
#FULL ASTEROIDS, DO NOT SPAWN NORMALLY 
execute if score spawning_roll astro_game.obstacles matches -1 as @e[tag=obstacle_spawner,limit=3,sort=random] run function astro_game:obstacles/entities/asteroid
#The rest
execute if score spawning_roll astro_game.obstacles matches 1 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/asteroid
execute if score spawning_roll astro_game.obstacles matches 2 run function astro_game:obstacles/entities/patterns/blue_spaceship
execute if score spawning_roll astro_game.obstacles matches 3 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/blue_spaceship
execute if score spawning_roll astro_game.obstacles matches 4 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/boost_portal
execute if score spawning_roll astro_game.obstacles matches 5 as @e[tag=obstacle_spawner,limit=2,sort=random] run function astro_game:obstacles/entities/asteroid
execute if score spawning_roll astro_game.obstacles matches 6 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/shield_portal
execute if score spawning_roll astro_game.obstacles matches 7 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/red_spaceship
execute if score spawning_roll astro_game.obstacles matches 8 run function astro_game:obstacles/entities/patterns/orange_pattern
execute if score spawning_roll astro_game.obstacles matches 9 as @e[tag=obstacle_spawner,limit=3,sort=random] run function astro_game:obstacles/entities/yellow_spaceship
execute if score spawning_roll astro_game.obstacles matches 10 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/laser_portal
execute if score spawning_roll astro_game.obstacles matches 11 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/collectable
execute if score spawning_roll astro_game.obstacles matches 12 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/collectable_portal
execute if score spawning_roll astro_game.obstacles matches 13 as @e[tag=obstacle_spawner,limit=1,sort=random] run function astro_game:obstacles/entities/egg
execute if score spawning_roll astro_game.obstacles matches 14 run function astro_game:obstacles/entities/patterns/buffs
execute if score spawning_roll astro_game.obstacles matches 15 run function astro_game:obstacles/entities/patterns/blue_and_red
execute if score spawning_roll astro_game.obstacles matches 16 as @e[tag=obstacle_spawner,limit=3,sort=random] run function astro_game:obstacles/entities/boost_portal
execute if score spawning_roll astro_game.obstacles matches 17 as @e[tag=obstacle_spawner,limit=3,sort=random] run function astro_game:obstacles/entities/shield_portal
execute if score spawning_roll astro_game.obstacles matches 18 as @e[tag=obstacle_spawner,limit=3,sort=random] run function astro_game:obstacles/entities/laser_portal
execute if score spawning_roll astro_game.obstacles matches 19 as @e[tag=obstacle_spawner,limit=3,sort=random] run function astro_game:obstacles/entities/collectable_portal

#mark newly spawned obstacles with row tag
execute as @e[tag=obstacle, tag=!-1, tag=!0, tag=!1] positioned as @s if entity @e[tag=obstacle_spawner_-1,distance=0..1] run tag @s add -1
execute as @e[tag=obstacle, tag=!-1, tag=!0, tag=!1] positioned as @s if entity @e[tag=obstacle_spawner_0,distance=0..1] run tag @s add 0
execute as @e[tag=obstacle, tag=!-1, tag=!0, tag=!1] positioned as @s if entity @e[tag=obstacle_spawner_1,distance=0..1] run tag @s add 1


#reset counter
scoreboard players set spawning_counter astro_game.obstacles 0

# Check for speed increase
#increase counter
scoreboard players add speed_increase_counter astro_game.obstacles 1 
#If (counter == threshold) increase
execute if score speed_increase_counter astro_game.obstacles = speed_increase_threshold astro_game.obstacles if score speed astro_game.obstacles < speed_cap astro_game.obstacles run scoreboard players operation speed astro_game.obstacles += speed_increase_amount astro_game.obstacles
#if (counter == threshold) increase speed
execute if score speed_increase_counter astro_game.obstacles = speed_increase_threshold astro_game.obstacles run scoreboard players set speed_increase_counter astro_game.obstacles 0