# This function should run if the spawning preset is set to 3, returns a spawn id for function astro_game:obstacles/actions/spawn
## Hard mode
# - Single Egg [ID: 13], [Weight: 1]

# - Boost Portal [ID: 4], [Weight: 1]
# - Shield Portal [ID: 6], [Weight: 1]
# - Laser Portal [ID: 10], [Weight: 1]
# - Collectable Portal [ID: 12], [Weight: 1]
# - Buff Decision [ID: 14], [Weight: 1]

# - Collectable [ID: 11], [Weight: 5]

# - Blue Spaceship [ID: 2], [Weight: 10]
# - Red Spaceship [ID: 7], [Weight: 7]
# - Orange Spaceship + Double Red Spaceship [ID: 8], [Weight: 5]
# - Triple Shield Spaceship [ID: 9], [Weight: 5]
# - Double Asteroid + Blue Spaceship [ID: 3], [Weight: 7]
# - Double Blue Spaceship + Red Spaceship [ID: 3], [Weight: 7]

# - Double Asteroid [ID: 5], [Weight: 40]
# - Asteroid [ID: 1], [Weight: 8]

#Egg
execute if score spawning_roll astro_game.obstacles matches ..1 if score collected_egg astro_game.obstacles matches 0 run return 13 
execute if score spawning_roll astro_game.obstacles matches ..1 if score collected_egg astro_game.obstacles matches 1.. run return 1

#Boosts
execute if score spawning_roll astro_game.obstacles matches ..2 run return 4
execute if score spawning_roll astro_game.obstacles matches ..3 run return 6
execute if score spawning_roll astro_game.obstacles matches ..4 run return 10
execute if score spawning_roll astro_game.obstacles matches ..5 run return 12
execute if score spawning_roll astro_game.obstacles matches ..6 run return 14

#Collectable
execute if score spawning_roll astro_game.obstacles matches ..11 run return 11

#Enemies
execute if score spawning_roll astro_game.obstacles matches ..21 run return 2
execute if score spawning_roll astro_game.obstacles matches ..28 run return 7
execute if score spawning_roll astro_game.obstacles matches ..33 run return 8
execute if score spawning_roll astro_game.obstacles matches ..38 run return 9
execute if score spawning_roll astro_game.obstacles matches ..45 run return 3
execute if score spawning_roll astro_game.obstacles matches ..52 run return 15

#Asteroids
execute if score spawning_roll astro_game.obstacles matches ..92 run return 5
execute if score spawning_roll astro_game.obstacles matches ..100 run return 1